var coffee, coffeescript_support, default_locals, fs, path;
fs = require('fs');
path = require('path');
coffee = require('coffee-script');
exports.Config = (function() {
  function Config(locals, context) {
    var key, value, _base, _ref;
    this.locals = locals != null ? locals : {};
    this.context = context != null ? context : {};
    for (key in default_locals) {
      value = default_locals[key];
      if ((_ref = (_base = this.locals)[key]) == null) {
        _base[key] = value;
      }
    }
  }
  Config.prototype.runFile = function(file) {
    var code;
    this.locals.__filename = path.join(process.cwd(), file);
    this.locals.__dirname = process.cwd();
    this.locals.module.filename = this.locals.__filename;
    code = this.readAndCompile(file);
    return this.run(code);
  };
  Config.prototype.run = function(code) {
    return this.defineWith(code);
  };
  Config.prototype.readAndCompile = function(file) {
    var code;
    code = this.read(file);
    return coffee.compile(code);
  };
  Config.prototype.read = function(file) {
    return fs.readFileSync(file, 'utf8');
  };
  Config.prototype.defineWith = function(code) {
    return this.scoped(code)(this.context, this.locals);
  };
  Config.prototype.scoped = function(code) {
    code = String(code);
    if (code.indexOf('function') !== 0) {
      code = "function () {" + code + "}";
    }
    code = "" + coffeescript_support + " with(locals) {return (" + code + ").apply(context, args);}";
    return new Function('context', 'locals', 'args', code);
  };
  return Config;
})();
coffeescript_support = "var __slice = Array.prototype.slice;\nvar __hasProp = Object.prototype.hasOwnProperty;\nvar __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };\nvar __extends = function(child, parent) {\n  for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }\n  function ctor() { this.constructor = child; }\n  ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype;\n  return child;\n};\nvar __indexOf = Array.prototype.indexOf || function(item) {\n  for (var i = 0, l = this.length; i < l; i++) {\n    if (this[i] === item) return i;\n  }\n  return -1;\n};";
default_locals = {
  require: require,
  global: global,
  process: process,
  module: module,
  console: console
};